package mezz.jei.common.network.packets;

import mezz.jei.common.network.IPacketId;
import mezz.jei.common.network.PacketIdServer;
import mezz.jei.common.network.ServerPacketContext;
import mezz.jei.common.network.ServerPacketData;
import mezz.jei.core.config.GiveMode;
import net.minecraft.class_1799;
import net.minecraft.class_2540;
import mezz.jei.common.util.ServerCommandUtil;

public class PacketGiveItemStack extends PacketJei {
	private final class_1799 itemStack;
	private final GiveMode giveMode;

	public PacketGiveItemStack(class_1799 itemStack, GiveMode giveMode) {
		this.itemStack = itemStack;
		this.giveMode = giveMode;
	}

	@Override
	public IPacketId getPacketId() {
		return PacketIdServer.GIVE_ITEM;
	}

	@Override
	public void writePacketData(class_2540 buf) {
		buf.method_10793(itemStack);
		buf.method_10817(giveMode);
	}

	public static void readPacketData(ServerPacketData data) {
		class_2540 buf = data.buf();
		class_1799 itemStack = buf.method_10819();
		if (!itemStack.method_7960()) {
			GiveMode giveMode = buf.method_10818(GiveMode.class);
			ServerPacketContext context = data.context();
			ServerCommandUtil.executeGive(context, itemStack, giveMode);
		}
	}
}
